#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <gtk/gtk.h> 

#include <gmodule.h>




#include "nSX2.h"
#include "PS2Edefs.h"

extern char * debug_r5900_reg [34];

/*Widget Variables Declarations*/
GtkWidget *win; 
GtkWidget *vbox;
GtkWidget *menu_bar;
GtkWidget *submenu;
GtkWidget *menu_item;
GtkWidget *scrollbar;

static GtkWidget *StatusBar; 
guint ContextId1;
guint ContextId2;

GtkWidget *EmuOutput;

/*************************************/
GtkWidget *winDebug;
GtkWidget *Debugvbox;
GtkWidget *Debughbox;

GtkWidget *DebugLabelRegCPUName [34];
GtkWidget *DebugLabelRegCPUValue[34]; 

 
/* nSX2 Variables Declarations */
Mips_CPU 		MipsCpu;
Bios_Hw  		Ps2Bios;
char 			ElfToExecute[256];
char            GSPlugginToUse[256];
_u16            INTERPRETER_MODE;
_u16            previous_INTERPRETER_MODE;


/* GTK Functions Declarations */
guint 	nSX2Idle_funcID;
int 	nSX2InitProc  		(GtkWidget *pWidget, gpointer pData );
int 	nSX2MainEmuProc 	(GtkWidget *pWidget, gpointer pData );
int 	nSX2Idle_nullfunc	(GtkWidget *pWidget, gpointer pData );

void 	arreter_boucle		(GtkWidget* widget); 
void    gtkErrorEmulator    (GtkWidget* widget, gpointer data);

void 	Quitter				(GtkWidget* widget, gpointer data);
void 	About				(GtkWidget* widget, gpointer data);

void 	gtkcb_LoadElf		(GtkWidget* widget, gpointer data);
void 	recuperer_chemin 	(GtkWidget* bouton, GtkWidget *file_selection);

void 	gtkcb_EmuRun		(GtkWidget* widget, gpointer data);
void 	gtkcb_EmuPause		(GtkWidget* widget, gpointer data);
void 	gtkcb_DbgShow 		(GtkWidget* widget, gpointer data);

void    gtkcb_CPUConf       (GtkWidget* widget, gpointer data);
void    gtkcb_GSConf       (GtkWidget* widget, gpointer data);


void 	gtkcb_HideWinDebug  (GtkWidget* widget, gpointer data);

/* nSX2 Functions Declarations */
float 	ComputeInstructionsPerSec		( void  );

void 	PrintToEmuOutput 				( char * ftext );
void 	PrintToOpcodeOutput 			( char * ftext );
void 	PrintToRegistersOutput 			( char * ftext );
void 	PrintToCOP1RegistersOutput 		( char * ftext );

GTimer * GTimer_IPS;



/* MAIN FUNCTION */
int main(int argc,char* argv[])
{ 


	char tempText[100];

	/* Read config File
		If errors happend, no problem this functions load default config
	*/
	nSX2LoadConfig();							

	/*Main GTK Init*/
	gtk_init(&argc,&argv);
 	
	/*Main Window*/
	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);                      //
	sprintf(tempText,"nSX2 %d.%2.2d",  nSX2_VERSION, nSX2_BUILD);	
    gtk_window_set_title(GTK_WINDOW(win),tempText);            //Title
	gtk_window_set_default_size(GTK_WINDOW(win),500,400);           //Size
	gtk_window_set_position(GTK_WINDOW(win), GTK_WIN_POS_CENTER );  //Center Position
   	
	
	
	/*Main Box*/
	vbox=gtk_vbox_new(FALSE,0);
	gtk_container_add(GTK_CONTAINER(win),vbox);
	
	/*Main Menu*/
	menu_bar = gtk_menu_bar_new();
	
	/*File Sub Menu*/
	submenu = gtk_menu_new();
	/*Menu Item : Load elf*/
	menu_item = gtk_menu_item_new_with_label("Load Elf");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_LoadElf), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/*Menu Item : Quit*/
	menu_item = gtk_menu_item_new_with_label("Exit");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(Quitter), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/*Sub Menu Name*/
	menu_item = gtk_menu_item_new_with_label("File");
	/*Add Sub Menu to Menu Bar*/
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);
	
	
	/* Emulation Sub Menu*/
	submenu = gtk_menu_new();
	/* */
	menu_item = gtk_menu_item_new_with_label("Run");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_EmuRun), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/* */
	menu_item = gtk_menu_item_new_with_label("Pause");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_EmuPause), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/* */
	menu_item = gtk_menu_item_new_with_label("Emulation");
	/* */
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);
	
	
	/* Debug Sub Menu*/
	submenu = gtk_menu_new();
	/* */
	menu_item = gtk_menu_item_new_with_label("Show");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_DbgShow), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/* */
	menu_item = gtk_menu_item_new_with_label("Debug");
	/* */
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);
	
	
	/* Config Sub Menu */
	submenu = gtk_menu_new();
	/* */
	menu_item = gtk_menu_item_new_with_label("CPU");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_CPUConf), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/* */
	menu_item = gtk_menu_item_new_with_label("GS");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_GSConf), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/* */
	menu_item = gtk_menu_item_new_with_label("Config");
	/* */
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);
	
	
	/* About Sub Menu */
	submenu = gtk_menu_new();
	/* */
	menu_item = gtk_menu_item_new_with_label("About...");
	g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(About), win);
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
	/* */
	menu_item = gtk_menu_item_new_with_label("?");
	/* */
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);
	
	
	/*Emu Output*/
	EmuOutput=gtk_text_view_new();
	
	scrollbar = gtk_scrolled_window_new(NULL, NULL);
	
	gtk_container_add(GTK_CONTAINER(scrollbar),EmuOutput);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrollbar), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	
	
	/*Status Bar*/
	StatusBar = gtk_statusbar_new();
	
	ContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(StatusBar), "ExitMsg");
	ContextId2 = gtk_statusbar_get_context_id(GTK_STATUSBAR(StatusBar), "AboutMsg");
	
	gtk_statusbar_push (GTK_STATUSBAR (StatusBar), GPOINTER_TO_INT(ContextId1), " ");
	
	
	/* Add Widget to Box*/
	gtk_box_pack_start(GTK_BOX(vbox), menu_bar, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox),EmuOutput,TRUE,TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox), scrollbar, TRUE, TRUE, 0);
	gtk_box_pack_end(GTK_BOX(vbox),StatusBar,FALSE,FALSE,0);
	
	/* */
	g_signal_connect(G_OBJECT(win),"destroy",G_CALLBACK(arreter_boucle),NULL);


    LoadGsPluggin(GSPlugginToUse);
    (*GSinit)();
	
	/* */

    gtk_widget_show_all(win);
	
	
	/* */
	gtk_main();
	
	return 0; 
}




void arreter_boucle(GtkWidget* widget)
{
//  char tempText[100];
//	PrintToEmuOutput("...Stop Interpreter");	
//	sprintf(tempText,"Stop at PC = 0x%8.8llx after %lld instructions",MipsCpu.PC, MipsCpu.Nb_instructions);
//	PrintToEmuOutput(tempText);	


	gtk_idle_remove    (nSX2Idle_funcID);


    g_timer_destroy (GTimer_IPS);
    //(*GSshutdown)();
	(*GSclose)();

	ElfCloseFile();
	FreeAllMemory();



	gtk_main_quit();
}



void Quitter(GtkWidget* widget, gpointer data)
{
	GtkWidget *question;
	
	question = gtk_message_dialog_new (GTK_WINDOW(data),
	GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
	GTK_MESSAGE_QUESTION,
	GTK_BUTTONS_YES_NO,
	"Really want to quit ?");
	
	switch(gtk_dialog_run(GTK_DIALOG(question)))
	{
		case GTK_RESPONSE_YES: {
			arreter_boucle(data);
			break;
		}
		
		case GTK_RESPONSE_NO: {
			gtk_widget_destroy(question);
			break;
		}
		
		default: break;
	}
}



void gtkErrorEmulator(GtkWidget* widget, gpointer data)
{
	GtkWidget *about;
		
	about = gtk_message_dialog_new (GTK_WINDOW(data),
	GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,
	"Sorry, Emulator Error",NULL);
	
	gtk_dialog_run(GTK_DIALOG(about));
	
	gtk_widget_destroy(about);
	
	arreter_boucle(data);
}


/*****************************************************************************/

void About(GtkWidget* widget, gpointer data)
{
	GtkWidget *about;
	gchar *site = "http://nsx2.emulation64.com";
	
	about = gtk_message_dialog_new (GTK_WINDOW(data),
	GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,
	"neutrinoSX2 v0.0.5\nAn open source PS2 Emulator\n\nby muad\n%s",site);
	
	gtk_dialog_run(GTK_DIALOG(about));
	
	gtk_widget_destroy(about);
}

/*****************************************************************************/
void gtkcb_LoadElf(GtkWidget* widget, gpointer data) {

	GtkWidget *selection;
	
	selection = gtk_file_selection_new( g_locale_to_utf8( "Slectionnez un fichier", -1, NULL, NULL, NULL) );
	
	gtk_file_selection_set_filename (GTK_FILE_SELECTION(selection),"demos\\");
	gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION(selection)); 
	
	gtk_widget_show(selection);
	
	//On interdit l'utilisation des autres fenetres.
	gtk_window_set_modal(GTK_WINDOW(selection), TRUE);
	
	g_signal_connect(G_OBJECT(GTK_FILE_SELECTION(selection)->ok_button), "clicked", G_CALLBACK(recuperer_chemin), selection );
	
	g_signal_connect_swapped(G_OBJECT(GTK_FILE_SELECTION(selection)->cancel_button), "clicked", G_CALLBACK(gtk_widget_destroy), selection);


}




void recuperer_chemin (GtkWidget *bouton, GtkWidget *file_selection)
{
	
	const gchar* chemin;
//	GtkWidget *dialog;
	chemin = gtk_file_selection_get_filename(GTK_FILE_SELECTION (file_selection) );
	
	
//	gtk_dialog_run(GTK_DIALOG(dialog));
//	gtk_widget_destroy(dialog);
	gtk_widget_destroy(file_selection);
	
	memset( ElfToExecute,0,50);
	strcpy( ElfToExecute,chemin);
	
	/*Change the Idle proc of the Gui*/
	gtk_idle_remove    (nSX2Idle_funcID);
	nSX2Idle_funcID = gtk_idle_add( (GtkFunction)nSX2InitProc ,  NULL );

} 
/*****************************************************************************/


void gtkcb_EmuRun(GtkWidget* widget, gpointer data)
{

	MipsCpu.halt = 0;
	
}
/*****************************************************************************/

void gtkcb_EmuPause(GtkWidget* widget, gpointer data)
{

	MipsCpu.halt = 1;
	
}

/*****************************************************************************/

void gtkcb_DbgShow (GtkWidget* widget, gpointer data)
{
    _u8 boucle;

 /*
	winDebug = gtk_window_new(GTK_WINDOW_TOPLEVEL);   

    gtk_window_set_title(GTK_WINDOW(winDebug),"Debugger");            //Title
	gtk_window_set_default_size(GTK_WINDOW(winDebug),640,480);           //Size
	gtk_window_set_position(GTK_WINDOW(winDebug), GTK_WIN_POS_CENTER );  //Center Position
    
	g_signal_connect(G_OBJECT(winDebug),"destroy",G_CALLBACK(gtkcb_HideWinDebug),NULL);


	
	//Main Box
	Debugvbox=gtk_vbox_new(FALSE,0);
    
	gtk_container_add(GTK_CONTAINER(winDebug),Debugvbox);

    for ( boucle = 0 ; boucle < 34 ; boucle ++ ) {
        Debughbox=gtk_hbox_new(FALSE,0);
        DebugLabelRegCPUName[ boucle ]=gtk_label_new(debug_r5900_reg[boucle]);
        DebugLabelRegCPUValue[ boucle ]=gtk_label_new("0000000000");
        gtk_box_pack_start(GTK_BOX(Debughbox), DebugLabelRegCPUName[ boucle ], FALSE, FALSE, 10);
        gtk_box_pack_start(GTK_BOX(Debughbox), DebugLabelRegCPUValue[ boucle ], FALSE, FALSE, 10);

        gtk_box_pack_start(GTK_BOX(Debugvbox), Debughbox, TRUE, TRUE, 0);
    }



	gtk_widget_show_all(winDebug);
*/	
}


void 	gtkcb_HideWinDebug  (GtkWidget* widget, gpointer data) {


        gtk_widget_destroy(widget);

}

/*****************************************************************************/

void    gtkcb_CPUConf       (GtkWidget* widget, gpointer data) {

	GtkWidget* winCPUConf   ;
	GtkWidget* Label1CPUConf  ;
	GtkWidget* boxEmulationModeCPUConf , *radio1,*radio2,*entry;
	
	gboolean  boxEmulationModeCPUConf_result;
	
	
	GtkWidget *msg;
	GtkWidget *window;
	GSList *temp;
	gchar *label;
	
	
	/* Create a New Dialog Window */
	winCPUConf=gtk_dialog_new_with_buttons("Cpu Configuration",GTK_WINDOW(data),
	GTK_DIALOG_MODAL,
	GTK_STOCK_OK,GTK_RESPONSE_OK,
	GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL,NULL);
	
	/* Create the Title Bold */
	Label1CPUConf=gtk_label_new(NULL);
	gtk_label_set_markup(GTK_LABEL(Label1CPUConf),
	      g_locale_to_utf8("<b>Emulation Mode</b>",-1, NULL, NULL, NULL));
	
	
	/* Add the Title to the Windows */
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(winCPUConf)->vbox),Label1CPUConf);


   	/* Create a New Vert. Box */
   	boxEmulationModeCPUConf = gtk_vbox_new (TRUE, 2);
   
	/* Create a radio button with a label */
    radio1 = gtk_radio_button_new_with_label(  NULL, "Normal");
    /* Create a Rafio Button from an another one */
   	radio2 = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (radio1),"Fast");
   
	/* Pack them into a box */
	gtk_box_pack_start (GTK_BOX (boxEmulationModeCPUConf), radio1, TRUE, TRUE, 2);
	gtk_box_pack_start (GTK_BOX (boxEmulationModeCPUConf), radio2, TRUE, TRUE, 2);
	

	/*Add the Box to the Windows */
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(winCPUConf)->vbox),boxEmulationModeCPUConf);

	/* Add a warning Msg */
    Label1CPUConf=gtk_label_new("WARNING! After a change, you must reload the .elf");
    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(winCPUConf)->vbox),Label1CPUConf);

	
	/*Set Initial State of Radios Buttons*/
	if ( INTERPRETER_MODE == 0 ) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio1),TRUE);
	if ( INTERPRETER_MODE == 1 ) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio2),TRUE);
	
	/* Show the Dialog Box */
	gtk_widget_show_all(GTK_DIALOG(winCPUConf)->vbox);
	
	switch (gtk_dialog_run(GTK_DIALOG(winCPUConf)))
	{
		case GTK_RESPONSE_OK:
		
			boxEmulationModeCPUConf_result = 0;
			//Recuperation liste des boutons
			temp = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radio1));
			
			while(temp) {
				//Test active
				if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(temp->data)))
				{
				//Oui alors on copie le texte puis on met temp a NULL
				//label = gtk_button_get_label(GTK_BUTTON(temp->data));
				temp = NULL;
			
				}
				else {
					//Non : on passe au suivant
					temp = g_slist_next(temp);
					boxEmulationModeCPUConf_result++;
				}
			}
			
			
			previous_INTERPRETER_MODE = INTERPRETER_MODE;
			
			switch( boxEmulationModeCPUConf_result ) {
			
				case 0: 	INTERPRETER_MODE = 1;	break;
				case 1:		INTERPRETER_MODE = 0; 	break;
				default: 	INTERPRETER_MODE = 0; 	break;
			
			}
			
		
		
		break;
		
		case GTK_RESPONSE_CANCEL:
		
		case GTK_RESPONSE_NONE:
		 
		default:
		
		
		break;
	} 


	// destruction de la bote de dialogue
	gtk_widget_destroy(winCPUConf); 


}



/*****************************************************************************/

int nSX2Idle_nullfunc(GtkWidget *pWidget, gpointer pData) { return TRUE; }

_s32   hWND;

/*
Initialisation of the EMU
*/
int nSX2InitProc  (GtkWidget *pWidget, gpointer pData ) {
	char 		tempText[100];		//for displaying text to the widget
	static int 	nsx2InitState = 0;	//Function State
	static int	IsInitOK = 0;		//
	int 		result;				//fonction return 
	char 		GSMainTitle[256];	//main windows title	

	GtkTextBuffer* text_buffer=0;
	GtkTextIter end_text_buffer,start_text_buffer;

	switch ( nsx2InitState ) {
		/* Print some infos */
		case 0:	{
/*
            text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(EmuOutput));
            gtk_text_buffer_get_end_iter (text_buffer,&end_text_buffer);
            gtk_text_buffer_get_start_iter (text_buffer,&start_text_buffer);
			gtk_text_buffer_delete(text_buffer, &start_text_buffer, &end_text_buffer);
 */           

   			sprintf(tempText,"nSX2 %d.%2.2d by Muad - 2002 ( build date : %s )",  nSX2_VERSION, nSX2_BUILD,sSX2_BUILD_DATE);
			PrintToEmuOutput(tempText);	
			
			sprintf(tempText,"|  web  : http://nsx2.emulation64.com");
			PrintToEmuOutput(tempText);	
			
			sprintf(tempText,"|_ mail : atreides.muaddib@caramail.com");
			PrintToEmuOutput(tempText);		
		
			IsInitOK = 0;

			break;
		}
		
		/*Open the elf File */
		case 1: {
		    
			result = ElfOpenFile(ElfToExecute);					if ( result == FALSE )  IsInitOK++;



			break;			
		}
		
		/*Open the BIOS File */
		case 2: {
			//result = BiosOpenFile( "bios/scph10000.bin" ) ;		if ( result == FALSE )  IsInitOK++;
			break;		
		}
		
		/*Various Memory Allocation */
		case 3: {
			


			FreeAllMemory();
			
    		result = MipsMemoryAlloc();							if ( result == FALSE )  IsInitOK++;
			result = MipsSpecialAreaMemoryAlloc( );				if ( result == FALSE )  IsInitOK++;
			result = MipsGSAreaMemoryAlloc();					if ( result == FALSE )  IsInitOK++;
			result = MipsBiosMemoryAlloc( );					if ( result == FALSE )  IsInitOK++;
			
			
			
			break;
		}
	
		
		/*If something wrong*/
		case 4: {
			if ( IsInitOK != 0 ) {
				sprintf(tempText,"FATAL ERROR while emulator initialisation....Sorry Exiting");	
				PrintToEmuOutput(tempText);
				gtkErrorEmulator(pWidget, NULL);
			}
			break;
		}
	
		/*Read the header of the Elf File*/
		case 5: {
			
			ElfLoadHeader();
			
			break;
		}
	
		/*Copy the program to memory according the elf header*/
		case 6: {	
		CopyProgramToMemory(  ) ;
			break;
		}
		
		/*Copy data to memory according the elf header*/
		case 7: {	
			CopySectionToMemory( );
			break;
		}
		
		/*Copy Bios to Memory */
		case 8: {
			//CopyBiosToMemory ( );	
			break;	
		}
	
		/* Initialisation of GS plugin */
		case 9: {	
		            
			//result = GSopen(MainScreen ,GSMainTitle );
            result = (*GSopen)(&hWND ,"Video Output" );
		
			if ( result != 0 ) {
				sprintf(tempText,"FATAL ERROR while graphics initialisation...Sorry Exiting");
				PrintToEmuOutput(tempText);
				gtkErrorEmulator(pWidget, NULL);
				
			} else {
				sprintf(tempText,"GS:OK");
				PrintToEmuOutput(tempText);			
			}
			break;	
		}

		/*Various PS2 Initialisation */
		case 10: {	
			
			Ps2Bios.NeedUpdateScreen 			= 0;
			MipsCpu.PC 							= MipsCpu.EntryPointAdd ;	//Start Program At Addr
			MipsCpu.GPR[CPU_REG_GP].lo			= 0x81F80000;				//GP
			MipsCpu.GPR[CPU_REG_SP].lo			= 0x81F00000;				//SP
			MipsCpu.CPR0[12][0]					= 0x10900001;				//Reg Status of COP0
			MipsCpu.CPR0[15][0]					= 0x2E20	;				//Reg PrID of COP0
			MipsCpu.Nb_instructions 			= 0;
			Ps2Bios.NbSema 						= 0;
			
			
			/*
			Create some pointeurs to val for performing the conversion by value of :
			int to float 
			and 
			float to int
			without change the way of store
			for exemple :
				0x4863D000 = 233280.0000
				and not
				0x4863D000 = 1214500864.0000
			*/
			for ( result = 0 ; result < 32 ; result++ ) {
			
			     MipsCpu.FPR1_p_float[result]=(float *)&(MipsCpu.FPR1[result].lo);
   
                }
			
			/*Temp Debug print*/
			printf("Nb Of Prog Section : %ld \n",MipsCpu.NbOfExecutableSection);
			printf("Prog Start Add %lx - End : %lx\n",MipsCpu.OpcodeStartAdd[0],MipsCpu.OpcodeEndAdd[0]); 
			
			
			
			
			if ( INTERPRETER_MODE == 1 ) MipsCpuPrefetchOpcode();
			else {
				MipsCpu.ListPrefetchedOpcode = malloc ( ( sizeof (CpuOpcodePrefetch * )) * 2 );
				if ( MipsCpu.ListPrefetchedOpcode == NULL ) printf("ERROR ALLOC MEM\n");
				
				MipsCpu.ListPrefetchedOpcode[0] = malloc ( sizeof ( CpuOpcodePrefetch ) );
				if ( MipsCpu.ListPrefetchedOpcode[0] == NULL ) printf("ERROR2 ALLOC MEM\n");
				
				printf("ALLOC OK\n\n");
				fflush(stdout);
			}
			
			
			break;
			
		}	

		/* Emulation Start Here...*/
		case 11: {
			/*Change the Idle proc of the Gui*/
            gtk_idle_remove    (nSX2Idle_funcID);
			nSX2Idle_funcID = gtk_idle_add( (GtkFunction)nSX2MainEmuProc ,  NULL );
           	
           	MipsCpu.halt = 0;
			nsx2InitState = 0;

            GTimer_IPS = g_timer_new ();

			
				
			sprintf(tempText,"Start Interpreter....");
			PrintToEmuOutput(tempText);	
			break;
		}
		
		/* MUST NEVER DO THIS */
		default: {
			sprintf(tempText,"Too Bad Muad...");
			PrintToEmuOutput(tempText);	
			break;
		}
		
	}
	
	/* next State when calling again this fucntion */
	nsx2InitState ++;
	
	return TRUE;
}




/*
Main Function of the EMU
*/
int nSX2MainEmuProc (GtkWidget *pWidget, gpointer pData ) {
		
		_u16	boucle;
		// For debugging... 
		//if ( MipsCpu.PC == 0x00404158) debug_op = 1;				//...after acessing a opcode
		//if ( MipsCpu.Nb_instructions > 557000 ) debug_op = 1;		//...after a number of opcode
		
		//if ( MipsCpu.PC == 0x00202930 ) result++;	
		//if ( result == 1 ) debug_op = 1;	
				
	/*
		If the debug mode is running, I can't exec a block of opcode
	
	*/
	
	
	
	switch( MipsCpu.halt ) {

		case 0: 
			if ( debug_op == 0 ) {
				for ( boucle = 0 ; boucle < 1000 ; boucle ++ ) MipsUpdateCpu(); //Execute a Block of opcodes
			} else MipsUpdateCpu();												//Execute the current opcode
			
		break;
		
		case 2:
			MipsUpdateCpu();	//Execute the current opcode
			MipsCpu.halt = 1;	//And Stop
		break;
		
		
	}
	
	/*Execute DMA stuff*/
	DmaUpdate();
	
	/*Execute GS stuff*/
	GSUpdate();
	
	
	/* In future add other stuff like PadUpdate , SoundUpdate , etc.... */
	

	

	if ( Ps2Bios.MustExecHandler == DMA_CH5 ) {
	  
	   if ( ( MipsCpu.PC < Ps2Bios.DmaH[ DMA_CH5 ].Add ) || ( MipsCpu.PC >= Ps2Bios.DmaH[ DMA_CH5 ].EndAdd ) ) {
	   
	       MipsCpu.PC = Ps2Bios.DmaH[ DMA_CH5 ].ReturnAdd;
	       Ps2Bios.MustExecHandler =   0xFFFF;
           printf("\nEnd Handler\n");
	       
        }
	  
	
	}
/*	
	if ( MipsCpu.PC == 0x040EB40) {
            debug_op = 1;
            MipsCpu.halt = 1;
            }
*/           	

    ComputeInstructionsPerSec();
	
	return TRUE;

}


/*
Freq CPU = 300 Mhz
436MIPS ( Million of Instruction per Second )
436 000 000
*/

float ComputeInstructionsPerSec( void  ) {

        static gdouble	PreviousTime = 0.0;
        gulong Timemicroseconds;
        static _u32	PreviousNbInstruction = 0;
        
        gdouble	CurrentTime;
        float	InstPerSec;
        
        char temp_string [100];
        
        
	
        CurrentTime =  g_timer_elapsed (GTimer_IPS, &Timemicroseconds);

		if ( CurrentTime < PreviousTime ) PreviousTime = 0.0;
	
		if ( ( CurrentTime - PreviousTime ) > 1.0 ) {


			InstPerSec = (float)(( MipsCpu.Nb_instructions - PreviousNbInstruction ) * ( ( CurrentTime - PreviousTime ) )) / 1000000.0;

			sprintf(temp_string,"CPU Speed:%10.6f MIPS\n",InstPerSec);

			gtk_statusbar_push (GTK_STATUSBAR (StatusBar), GPOINTER_TO_INT(ContextId1), g_locale_to_utf8(temp_string, -1, NULL, NULL, NULL));
	
			PreviousNbInstruction = MipsCpu.Nb_instructions;
			PreviousTime = 	CurrentTime;
		}

}


void PrintToEmuOutput (  char * ftext ) {
	
	GtkTextBuffer* text_buffer=0;
	GtkTextIter end;

	
	text_buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(EmuOutput));
	gtk_text_buffer_get_end_iter(text_buffer,&end);

	
	gtk_text_buffer_insert(text_buffer, &end, g_locale_to_utf8(ftext, -1, NULL, NULL, NULL), -1);
	gtk_text_buffer_insert(text_buffer, &end, g_locale_to_utf8("\n", -1, NULL, NULL, NULL), -1);

}

void PrintToOpcodeOutput (  char * ftext ) {


}

void PrintToRegistersOutput (  char * ftext ) {
	


} 

void PrintToCOP1RegistersOutput (  char * ftext ) {
	


} 




void    gtkcb_GSConf       (GtkWidget* widget, gpointer data) {
 

    (*GSconfigure)();
}






